#![allow(deprecated)]
use std::fmt;
use std::str;
/// Shape rendered for each point in the cloud.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum SpatialSplatMode {
    #[serde(rename = "BALL")]
    Ball,
    #[serde(rename = "PARABOLIC")]
    Parabolic,
    #[serde(rename = "DISC")]
    Disc,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl SpatialSplatMode {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            SpatialSplatMode::Ball => "BALL",
            SpatialSplatMode::Parabolic => "PARABOLIC",
            SpatialSplatMode::Disc => "DISC",
            SpatialSplatMode::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for SpatialSplatMode {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for SpatialSplatMode {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for SpatialSplatMode {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<SpatialSplatMode, conjure_object::plain::ParseEnumError> {
        match v {
            "BALL" => Ok(SpatialSplatMode::Ball),
            "PARABOLIC" => Ok(SpatialSplatMode::Parabolic),
            "DISC" => Ok(SpatialSplatMode::Disc),
            v => v.parse().map(|v| SpatialSplatMode::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for SpatialSplatMode {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<SpatialSplatMode, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the SpatialSplatMode enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
